package org.cis1200;

/**
 * This simple interface produces numbers. This interface is implemented for
 * you.
 * <p>
 * It is used in MarkovChain and ProbabilityDistribution with just
 * two implementations: RandomNumberGenerator and ListNumberGenerator,
 * the first of which is useful for producing random numbers and thus
 * is good for the bot in practice, the latter of which can be passed
 * a list for deterministic testing of the bot.
 */
public interface NumberGenerator {
    /**
     * Generates a number based off of a specified bound.
     *
     * @param bound - the max value that can be returned by the generator.
     * @return a number between 0 (inclusive) and bound (exclusive).
     */
    int next(int bound);
}
