package org.cis1200;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

import java.time.Duration;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

/** Tests for ChatterBot class */
public class ChatterBotTest {
    // A helper function for creating lists of strings
    private static List<String> listOfArray(String[] words) {
        List<String> l = new LinkedList<>();
        Collections.addAll(l, words);
        return l;
    }

    /*
     * The below test case test whether your ChatterBot class itself is written
     * correctly. To generate a post of specific content, make a walk
     * containing the indices of the words you want to appear in the post and
     * use that as the {@code NumberGenerator}
     */

    private static final String[] POST_1 = { "a", "table", "and", "a", "chair" };
    private static final String[] POST_2 = { "a", "banana", "!", "and", "a", "banana", "?" };

    private static List<List<String>> getTestTrainingDataExample() {
        List<List<String>> trainingData = new LinkedList<>();
        trainingData.add(listOfArray(POST_1));
        trainingData.add(listOfArray(POST_2));
        return trainingData;
    }

    @Test
    public void generatorWorks() {
        ChatterBot cb = new ChatterBot(getTestTrainingDataExample());

        String expected = "a banana?";
        int[] walk = { 0, 0, 1, 0 };
        NumberGenerator ng = new ListNumberGenerator(walk);
        assertEquals(expected, cb.generatePost(ng));
    }

    /**
     * When the training data is empty, your ChatterBot should create an empty
     * MarkovChain.
     * An empty post should be generated by your bot.
     * No exceptions should be thrown and your program should not go into an
     * infinite loop!
     */
    @Test
    public void emptyTrainingDataCreatesEmptyPost() {
        // Checks that your program does not go into an infinite loop
        assertTimeoutPreemptively(
                Duration.ofSeconds(10), () -> {
                    // No exceptions are thrown if training data is empty
                    ChatterBot cb = new ChatterBot(new LinkedList<>());
                    // Checks that the bot creates an empty post
                    assertEquals(0, cb.generatePost().length());
                }
        );
    }

    /*
     * Add additional test cases here, modeled after the generatorWorks test shown
     * above.
     */

}
